=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2007-02-12 01:00:52 +0000
+++ bzrlib/dirstate.py	2007-02-12 01:10:00 +0000
@@ -413,7 +413,7 @@
             # so we just skip over it
             # number of fields per dir_entry + number of fields per parent_entry + newline
             num_parents = len(self._parents)
-            entry_size = 7 + (7 * num_parents) + 1
+            entry_size = 7 + (7 * (num_parents - len(self._ghosts))) + 1
             expected_field_count = entry_size * self._num_entries
             # is the file too short ?
             assert field_count - cur == expected_field_count, \

=== modified file 'bzrlib/tests/test_dirstate.py'
--- bzrlib/tests/test_dirstate.py	2007-02-12 00:32:19 +0000
+++ bzrlib/tests/test_dirstate.py	2007-02-12 01:10:00 +0000
@@ -314,7 +314,9 @@
         # the ghost should be recorded as such by set_parent_trees.
         self.assertEqual(['ghost-rev'], state.get_ghosts())
         self.assertEqual(
-            [(('', '', 'directory', root_id, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', ''), [])],
+            [(['', '', 'directory', root_id, 0, 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', ''], [
+             (revid1, 'directory', '', '', 0, False, ''),
+             (revid2, 'directory', '', '', 0, False, '')])],
             list(state._iter_rows()))
 
     ### add a path via _set_data - so we dont need delta work, just

